lang equ ru

;
;   Assembler
;     SMALL
;       CODE
;         Libary
;           KeyBoard
;             Driver
;
;   Ver 0.1 By Pavlushin Evgeni (RUSSIA)
;   www.waptap@mail.ru

;InfoList
;0.01 First test

macro kbdinit
{
   mov eax,66
   mov ebx,1
   mov ecx,1
   int 0x40

   jmp skip_kmap
keymap:
rb 300
skip_kmap:
}

macro kbdhandler
{
   mov eax,2
   int 0x40
   shr eax,8
   and eax,0xff
   mov ah,al
   mov ebx,0
   mov bl,ah
   cmp bl,224  ;ignore ext code
   je  no_isa
   cmp bl,170  ;ignore keyup code
   je  no_isa
   cmp bl,128
   ja  isa
   mov [keymap+ebx],byte 1
   jmp no_isa
isa:
   sub bl,128
   mov [keymap+ebx],byte 0
no_isa:
}

; READ KEY (RESET)

macro rkeyonoff scan_of_key,varible
{
local key_1,key_0,n_key
   cmp byte [keymap+scan_of_key],0
   je  n_key
   mov byte [keymap+scan_of_key],0
   cmp [varible],1
   je  key_1
key_0:
   mov [varible],1
   jmp n_key
key_1:
   mov [varible],0
n_key:
}

macro rkeyhandler scan_of_key,no_meta
{
local is_key
   cmp byte [keymap+scan_of_key],0
   jne is_key
   mov byte [keymap+scan_of_key],0
   jmp no_meta
is_key:
}

macro rkeyjmp scan_of_key,jmp_meta
{
local no_key
   cmp byte [keymap+scan_of_key],0
   je  no_key
   mov byte [keymap+scan_of_key],0
   jmp jmp_meta
no_key:
}

macro rkeycontrol scan_of_sub,scan_of_add,stepsub,stepadd,min,max,varible
{
local no_key_sub,no_key_add
   cmp byte [keymap+scan_of_sub],0
   je  no_key_sub
   mov byte [keymap+scan_of_sub],0
   mov eax,stepsub
   sub varible,eax
   mov eax,min
   cmp varible,eax
   jnl no_key_sub
   mov varible,eax
no_key_sub:
   cmp byte [keymap+scan_of_add],0
   je  no_key_add
   mov byte [keymap+scan_of_add],0
   mov eax,stepadd
   add varible,eax
   mov eax,max
   cmp varible,eax
   jng no_key_add
   mov varible,eax
no_key_add:
}

; SCAN KEY (NO RESET)

macro keyonoff scan_of_key,varible
{
local key_1,key_0,n_key
   cmp byte [keymap+scan_of_key],0
   je  n_key
   cmp [varible],1
   je  key_1
key_0:
   mov [varible],1
   jmp n_key
key_1:
   mov [varible],0
n_key:
}

macro keyhandler scan_of_key,no_meta
{
   cmp byte [keymap+scan_of_key],0
   je no_meta
}

macro keyjmp scan_of_key,jmp_meta
{
   cmp byte [keymap+scan_of_key],0
   jne jmp_meta
}

macro keycontrol scan_of_sub,scan_of_add,stepsub,stepadd,min,max,varible
{
local no_key_sub,no_key_add
   cmp byte [keymap+scan_of_sub],0
   je  no_key_sub
   mov eax,stepsub
   sub varible,eax
   mov eax,min
   cmp varible,eax
   jnl no_key_sub
   mov varible,eax
no_key_sub:
   cmp byte [keymap+scan_of_add],0
   je  no_key_add
   mov eax,stepadd
   add varible,eax
   mov eax,max
   cmp varible,eax
   jng no_key_add
   mov varible,eax
no_key_add:
}


; many scan codes but not all
scan_Q equ 16
scan_W equ 17
scan_E equ 18
scan_R equ 19
scan_T equ 20
scan_Y equ 21
scan_U equ 22
scan_I equ 23
scan_O equ 24
scan_P equ 25
scan_Lsk equ 26
scan_Rsk equ 27
scan_A equ 30
scan_S equ 31
scan_D equ 32
scan_F equ 33
scan_G equ 34
scan_H equ 35
scan_J equ 36
scan_K equ 37
scan_L equ 38
scan_Dotcomma equ 39
scan_Upcomma equ 40
scan_Z equ 44
scan_X equ 45
scan_C equ 46
scan_V equ 47
scan_B equ 48
scan_N equ 49
scan_M equ 50
scan_Comma equ 51
scan_Dot equ 52
scan_Slash equ 53
scan_Tilda equ 41
scan_1 equ 2
scan_2 equ 3
scan_3 equ 4
scan_4 equ 5
scan_5 equ 6
scan_6 equ 7
scan_7 equ 8
scan_8 equ 9
scan_9 equ 10
scan_0 equ 11
scan_Minus equ 12
scan_Equal equ 13
scan_Fatslash equ 43
scan_Backspace equ 14
scan_Space equ 57
scan_Enter equ 28
scan_Num_Enter equ 28
scan_Esc equ 1



