;
;   Draw img to canvas Mini Sample by Pavlushin Evgeni for ASCL
;   www.waptap@mail.ru   www.deck4.narod.ru www.cyberdeck.fatal.ru
;

;******************************************************************************
    use32
    org    0x0
    db     'MENUET01'              ; 8 byte id
    dd     0x01                    ; header version
    dd     START                   ; start of code
    dd     IM_END                  ; size of image
    dd     I_END                   ; memory for app
    dd     I_END                   ; esp
    dd     temp_area , 0x0         ; I_Param , I_Icon

;******************************************************************************

include 'ascl.inc'
include 'ascgl.inc'

START:                          ; start of execution
    call draw_window

    loadfile '/RD/1/MFAR.BMP',temp_area,I_END
    bmptoimg temp_area,img
    loadfile '/RD/1/SMILE.BMP',temp_area,I_END
    bmptoimg temp_area,img2
    loadfile '/RD/1/COPY.BMP',temp_area,I_END
    bmptoimg temp_area,img3

still:
    mov  eax,11                 ; scan event
    int  0x40

    cmp  eax,1                  ; redraw request ?
    je   red
    cmp  eax,2                  ; key in buffer ?
    je   key
    cmp  eax,3                  ; button in buffer ?
    je   button

; put img
; edi xcor
; esi ycor

mov ecx,100   ;out 100 images and show canvas
loo:
    pushad
    random 600,edi
    random 420,esi
    imgtoimg img,edi,esi,canvas

    random 600,edi
    random 420,esi
    imgtoimg img2,edi,esi,canvas

    random 600,edi
    random 420,esi
    imgtoimg img3,edi,esi,canvas
    popad
    dec ecx
    jns loo

draw_canvas:
    setimg 5,21,canvas   ;output canvas
    delay 2              ;don't generate delay for fast speed programm
    jmp  still

  red:
    call draw_window
    jmp  still

  key:                          ; key
    mov eax,2
    int 0x40
    jmp  still

  button:                       ; button
    mov  eax,17                 ; get id
    int  0x40
    cmp  ah,1                   ; button id=1 ?
    jne  noclose
    mov  eax,-1                 ; close this program
    int  0x40
  noclose:
    jmp  still

draw_window:
    startwd
    window 0,0,640+8,480+24,window_Skinned
    label 12,8,'ASCL EXAMPLE: DRAW IMG TO CANVAS',cl_White+font_Big
    endwd
    ret

; DATA AREA
IM_END:

canvas:
canvas_x dd 640
canvas_y dd 480
rb (640*480*3)

img:
rd 32*32*3+8
img2:
rb 32*32*3+8
img3:
rb 32*32*3+8

temp_area:
rb 0x15000

I_END: ; = canvas+(640*480*3)+8
